Bug 968876 - e4defrag incorrectly calculates optimum extents
e4defrag incorrectly calculates optimum extents
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: e2fsprogs (Show other bugs)
18
All Linux
unspecified Severity low
: ---
: ---
Assigned To: Eric Sandeen
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-05-30 03:40 EDT by Joseph D. Wagner
Modified: 2014-02-05 16:35 EST (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-02-05 16:35:32 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Joseph D. Wagner 2013-05-30 03:40:16 EDT
The "Total/best extents" calculation for done in the e4defrag program doesn't seems to not consider the limit of 32768 file system blocks (see /usr/src/linux/fs/ext4/ext4_extents.h comment EXT_INIT_MAX_LEN) in an extent when computing the "best" value. It seems to presume 2G is the best extent size, but on a file system with a 4kb block size the largest available extent is 128M not 2G.

(The best extent size calculation in e4defrag seems to be based on block group size but the underlying implementaiton in the kernel is limited to a __le16 blocks and uses up one whole bit of that to flag whether the extent is initialized, which actually produces a one-block purturbation in the actual limit based on how the extent was allocated (e.g. whether falloc used FS_KEEP_SIZE or not), go go gadget purturbed math. 8-)).

Example:
-rw-r--r-- 1 rwhite rwhite 5.0G Jun 13 16:28 CentOS.qcow2

yeilds output: (where "/3" is wrong).

Total/best extents 152/3

Proposed patch available here:
http://pastebin.com/9XTFcVM0
Comment 1 Eric Sandeen 2013-05-30 11:50:13 EDT
It'd be great if you could take this discussion & patch to the upstream list, linux-ext4@vger.kernel.org.  It sounds like you have a good handle on things and could advocate for your patch - and TBH, this is low enough priority I may never get to it.

How ext[234] counts extents has always been dodgey, helpfully omitting things like indirect blocks on ext3, etc.

Consistency sounds good to me though.  Either we should report "an extent" as "contiguous blocks on disk" regardless of implementation, or somehow munge the idea based on the intricacies of ext4's on-disk format.
Comment 2 Fedora End Of Life 2013-12-21 08:46:55 EST
This message is a reminder that Fedora 18 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 18. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '18'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 18's end of life.

Thank you for reporting this issue and we are sorry that we may not be 
able to fix it before Fedora 18 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior to Fedora 18's end of life.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 3 Fedora End Of Life 2014-02-05 16:35:32 EST
Fedora 18 changed to end-of-life (EOL) status on 2014-01-14. Fedora 18 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.